//ANUBIS! - King Of The Underworld

/* CVARS - copy and paste to shconfig.cfg

//Anubis
anubis_level 0
anibus_showdamage 1		//(0|1) - hide|show bullet damage..
anibus_showchat 1		//(0|1) - hide|show ghostchat messages..

*/

/*
*   v1.17 - JTP10181
*	- Added ablily to disable the ghostchat like function
*		for servers that already have ghostchat
*/

#include <amxmodx>
#include <engine>
//#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Anubis"
new g_heroID
new bool:g_hasAnubis[SH_MAXSLOTS+1]
new g_msgSayText
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Anubis", "1.18", "AssKicR/JTP10181")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("anubis_level", "0")
	register_cvar("anibus_showdamage", "1")
	register_cvar("anibus_showchat", "1")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Dark Notices", "Nothing Is Secret From You. Hear Enemies - See Damage")
	sh_hero_bind(g_heroID, false)
	sh_hero_level(g_heroID, get_cvar_num("anubis_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// Damage Event
	register_event("Damage", "damage_msg", "b", "2!0", "3=0", "4!0")

	// Say
	register_clcmd("say", "handle_say")
	register_clcmd("say_team", "handle_say")

	g_msgSayText = get_user_msgid("SayText")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	// See if this hero is the same that's being init
	if ( g_heroID == heroID ) {
		g_hasAnubis[id] = (mode != 0)
		if ( mode == 1 ) {
			anubis_speak_on(id)
		}
		else {
			anubis_speak_off(id)
		}
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	if ( sh_server_info(SH_MODACTIVE) && g_hasAnubis[id] ) anubis_speak_on(id)
}
//----------------------------------------------------------------------------------------------
public handle_say(id)
{
	if ( !sh_server_info(SH_MODACTIVE) || !get_cvar_num("anibus_showchat") ) return

	new command[10], players[SH_MAXSLOTS]
	new message[191], name[33], player_count
	new teamname[5], sMessage[191]
	read_argv(0, command, 16)
	read_argv(1, message, 190)

	if ( equal(message, "") || equal(message, "[") ) return

	new is_alive = is_user_alive(id)
	new team = get_user_team(id)
	new isSayTeam = equal(command, "say_team")
	get_user_name(id, name, 32)

	if (team == 1) copy(teamname, 4, "(T)")
	else if (team == 2) copy(teamname, 4, "(CT)")

	format(sMessage,190, "%c[DN]%s%s%s :  %s^n", 2,  isSayTeam ? teamname : "", is_alive ? "*ALIVE*" : "*DEAD*", name, message)

	get_players(players, player_count, "c")

	for ( new i = 0; i < player_count; i++ ) {
		if ( g_hasAnubis[players[i]] && is_user_connected(players[i]) ) {
			if ( is_user_alive(players[i]) && !is_alive || isSayTeam && team != get_user_team(players[i]) ) {
				message_begin(MSG_ONE_UNRELIABLE, g_msgSayText, {0,0,0}, players[i])
				write_byte(id)
				write_string(sMessage)
				message_end()
			}
		}
	}
}
//----------------------------------------------------------------------------------------------
public anubis_speak_on(id)
{
	if ( g_hasAnubis[id] && is_user_connected(id) ) {
		set_speak(id, SPEAK_LISTENALL)
	}
}
//----------------------------------------------------------------------------------------------
public anubis_speak_off(id)
{
	if ( !g_hasAnubis[id] && is_user_connected(id) ) {
		set_speak(id, SPEAK_NORMAL)
	}
}
//----------------------------------------------------------------------------------------------
public damage_msg(vIndex)
{
	if ( !sh_server_info(SH_MODACTIVE) || !is_user_connected(vIndex) ) return

	if ( get_cvar_num("anibus_showdamage") ) {
		new aIndex = get_user_attacker(vIndex)
	
		if ( aIndex <= 0 || aIndex > SH_MAXSLOTS || vIndex <= 0 || vIndex > SH_MAXSLOTS  || vIndex == aIndex ) return

		new damage = read_data(2)
		if ( is_user_alive(aIndex) && g_hasAnubis[aIndex] ) {
			set_hudmessage(0, 100, 200, -1.0, 0.55, 2, 0.1, 2.0, 0.02, 0.02, 74)
			show_hudmessage(aIndex, "%i", damage)
		}

		if ( is_user_alive(vIndex) && g_hasAnubis[vIndex] ) {
			set_hudmessage(200, 0, 0, -1.0, 0.48, 2, 0.1, 2.0, 0.02, 0.02, 76)
			show_hudmessage(vIndex, "%i", damage)
		}
	}
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
{
	g_hasAnubis[id] = false
}
//----------------------------------------------------------------------------------------------