// BOMBERMAN! - From the NES :)

/* CVARS - copy and paste to shconfig.cfg

//Bomberman
bomberman_level 0
bomberman_cooldown 5		//Cooldown time from bomb explostion until new planting
bomberman_xpbased 0			//Does he get more bombs each level           (def=0)
bomberman_bombs 1			//How Many Bombs does he start with           (def=1)
bomberman_bpl 1			//How Many More Bombs Does he get each level  (def=1)
bomberman_radius 400		//Radius of damage			(def=400)
bomberman_maxdamage 100		//Maximum Damage to deal		(def=100)

*/

//Thanks to TheLooser & Demonic_Frost for help testing

#include <amxmodx>
#include <engine>
#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Bomberman"
new g_heroID
new bool:g_hasBomberman[SH_MAXSLOTS+1]
new g_bombEntity[SH_MAXSLOTS+1]
new g_bombAmmo[SH_MAXSLOTS+1]
new g_bombModel[33]
new g_spriteSmoke, g_spriteWhite, g_spriteFire, g_spriteExplode
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Bomberman", "1.18", "AssKicR")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("bomberman_level", "0")
	register_cvar("bomberman_cooldown", "5")
	register_cvar("bomberman_xpbased", "0")
	register_cvar("bomberman_bombs", "1")
	register_cvar("bomberman_bpl", "1")
	register_cvar("bomberman_radius", "400")
	register_cvar("bomberman_maxdamage", "100")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Remote Bombs", "Press +power button to plant, and again to detonate")
	sh_hero_bind(g_heroID, true)
	sh_hero_level(g_heroID, get_cvar_num("bomberman_level"))
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	//What Skin Is The Bomb Gonna Have
	if ( file_exists("models/shmod/bomberman_bomb.mdl") )
	{
		precache_model("models/shmod/bomberman_bomb.mdl")
		copy(g_bombModel,32,"models/shmod/bomberman_bomb.mdl")
	}
	else
	{
		precache_model("models/w_c4.mdl")
		copy(g_bombModel,32,"models/w_c4.mdl")
	}
	precache_sound("weapons/c4_plant.wav")
	g_spriteExplode = precache_model("sprites/zerogxplode.spr")
	g_spriteSmoke = precache_model("sprites/steam1.spr")
	g_spriteWhite = precache_model("sprites/white.spr")
	g_spriteFire = precache_model("sprites/explode1.spr")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( g_heroID == heroID )
	{
		g_hasBomberman[id] = (mode != 0)
		if ( g_hasBomberman[id] ) sh_new_spawn(id)
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	sh_uset(id, g_heroID, 0)

	if ( !g_hasBomberman[id] ) return

	if ( g_bombEntity[id] )
	{
		remove_entity(g_bombEntity[id])
		g_bombEntity[id] = 0
	}

	if ( get_cvar_num("bomberman_xpbased") == 1 )
	{
		//bombsb = ((level he is - level he must be) * bombs per level) + starting bombs
		new bombs = ((sh_get_user_lvl(id)-get_cvar_num("bomberman_level"))*get_cvar_num("bomberman_bpl")+get_cvar_num("bomberman_bombs"))

		if (bombs > 0)
		{
			g_bombAmmo[id] = bombs
		}
		else if (bombs == 0)
		{
			g_bombAmmo[id] = 1
		}
		else
		{
			g_bombAmmo[id] = 0
		}
	}
	else
	{
		new bombs = get_cvar_num("bomberman_bombs")
		g_bombAmmo[id] = bombs
	}
}
//----------------------------------------------------------------------------------------------
// RESPOND TO KEYDOWN
public sh_hero_key(id, heroID, key)
{
	if ( g_heroID != heroID || key != SH_KEYDOWN ) return
	if ( !sh_server_info(SH_INROUND) ) return
	if ( !is_user_alive(id) || !g_hasBomberman[id] ) return

	if ( g_bombEntity[id] > 0 ) {
		explode_bomb(id)
	}
	else {
		plant_bomb(id)
	}
}
//----------------------------------------------------------------------------------------------
public plant_bomb(id)
{
	if ( !is_user_alive(id) ) return
	if ( g_bombEntity[id] > 0 ) return

	if ( g_bombAmmo[id] == 0 )
	{
		playSoundDenySelect(id)
		client_print(id, print_center, "You have 0 bombs left")
		return
	}

	if ( sh_ustatus(id, g_heroID) )
	{
		playSoundDenySelect(id)
		return
	}

	g_bombEntity[id] = create_entity("info_target")
	if ( g_bombEntity[id] == 0 ) return

	entity_set_string(g_bombEntity[id], EV_SZ_classname, "remote_bomb")
	entity_set_model(g_bombEntity[id], g_bombModel)

	new Float:PlayerOrigin[3]
	entity_get_vector(id, EV_VEC_origin, PlayerOrigin)

	entity_set_origin(g_bombEntity[id], PlayerOrigin)

	entity_set_int(g_bombEntity[id], EV_INT_solid, 0)
	entity_set_int(g_bombEntity[id], EV_INT_movetype, 6)
	entity_set_edict(g_bombEntity[id], EV_ENT_owner, id)

	emit_sound(g_bombEntity[id], CHAN_WEAPON, "weapons/c4_plant.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

	g_bombAmmo[id]--
	client_print(id, print_center, "Bomb Planted: You have %d bombs left", g_bombAmmo[id])
}
//----------------------------------------------------------------------------------------------
public explode_bomb(id)
{
	if ( !is_user_alive(id) ) return
	if ( g_bombEntity[id] == 0 ) return

	sh_utimer(id, g_heroID, get_cvar_float("bomberman_cooldown"))

	new Float:vExplodeAt[3]
	entity_get_vector(g_bombEntity[id], EV_VEC_origin, vExplodeAt)

	blowUp(id, vExplodeAt)

	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(3)
	write_coord(floatround(vExplodeAt[0]))
	write_coord(floatround(vExplodeAt[1]))
	write_coord(floatround(vExplodeAt[2]))
	write_short(g_spriteExplode)
	write_byte(50)
	write_byte(15)
	write_byte(0)
	message_end()

	remove_entity(g_bombEntity[id])
	g_bombEntity[id] = 0
}
//----------------------------------------------------------------------------------------------
public blowUp(id, Float:vExplodeAt[3])
{
	new Float:dRatio, damage, distanceBetween, iExplodeAt[3]
	new damradius = get_cvar_num("bomberman_radius")
	new maxdamage = get_cvar_num("bomberman_maxdamage")
	new FFOn = get_cvar_num("mp_friendlyfire")

	//why is this here? to show the bomber I guess incase he's invisible?
	set_user_rendering(id)

	iExplodeAt[0] = floatround(vExplodeAt[0])
	iExplodeAt[1] = floatround(vExplodeAt[1])
	iExplodeAt[2] = floatround(vExplodeAt[2])+37

	// blowup even if dead
	explode(iExplodeAt)

	for(new a = 1; a <= SH_MAXSLOTS; a++)
	{
		if ( is_user_alive(a) && ( cs_get_user_team(id) != cs_get_user_team(a) || FFOn != 0 || a == id ) )
		{
			new PlayerOrigin[3]
			get_user_origin(a, PlayerOrigin)
			distanceBetween = get_distance(iExplodeAt, PlayerOrigin)
			if( distanceBetween < get_cvar_num("bomberman_radius") )
			{
				dRatio = float(distanceBetween) / float(damradius)
				damage = maxdamage - floatround(maxdamage * dRatio)
				sh_extradamage(a, id, damage, "Bomberman Bomb")
			} // distance
		} // alive target...
	} // loop
}
//----------------------------------------------------------------------------------------------
public explode(vec1[3])
{
	// blast circles
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY, vec1)
	write_byte(21)		// TE_BEAMCYLINDER
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2] + 16)
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2] + 1936)
	write_short(g_spriteWhite)
	write_byte(0)		// startframe
	write_byte(0)		// framerate
	write_byte(2)		// life
	write_byte(20)		// width 16
	write_byte(0)		// noise
	write_byte(188)	// r
	write_byte(220)	// g
	write_byte(255)	// b
	write_byte(255)	// brightness
	write_byte(0)		// speed
	message_end()

	//Explosion2
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(12)		// TE_EXPLOSION2
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_byte(188)	// scale in 0.1's
	write_byte(10)		// framerate
	message_end()

	//TE_Explosion
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY, vec1)
	write_byte(3)		// TE_EXPLOSION
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_short(g_spriteFire)
	write_byte(60)		// scale in 0.1's
	write_byte(10)		// framerate
	write_byte(0)		// flags
	message_end()

	//Smoke
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY, vec1)
	write_byte(5)		// TE_SMOKE
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_short(g_spriteSmoke)
	write_byte(10)		// scale in 0.1's  2
	write_byte(10)		// framerate
	message_end()
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
{
	if ( g_bombEntity[id] )
	{
		remove_entity(g_bombEntity[id])
	}
	g_bombEntity[id] = 0
	sh_uset(id, g_heroID, 0)
	g_hasBomberman[id] = false
}
//----------------------------------------------------------------------------------------------
public client_disconnect(id)
{
	if ( g_bombEntity[id] )
	{
		remove_entity(g_bombEntity[id])
	}
	g_bombEntity[id] = 0
	sh_uset(id, g_heroID, 0)
	g_hasBomberman[id] = false
}
//----------------------------------------------------------------------------------------------