// DAZZLER! - from the X-men. Creates light from soundwaves.

/* CVARS - copy and paste to shconfig.cfg

//Dazzler
dazzler_level 0
dazzler_radius 3000		//radius of people affected
dazzler_cooldown 15		//# of seconds before Dazzler can flash

*/

#include <amxmodx>
#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Dazzler"
new g_heroID
new bool:g_hasDazzlerPower[SH_MAXSLOTS+1]
new g_spriteFlare3, g_spriteFlare6, g_spriteBlueFlare2, g_spriteRedFlare2
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Dazzler", "1.18", "{HOJ} Batman")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("dazzler_level", "0")
	register_cvar("dazzler_radius", "3000")
	register_cvar("dazzler_cooldown", "15")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Sparkle Flash", "Flash Nearby Enemies - Grows in intensity as you level up")
	sh_hero_bind(g_heroID, true)
	sh_hero_level(g_heroID, get_cvar_num("dazzler_level"))
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	g_spriteFlare3 = precache_model("sprites/flare3.spr")
	g_spriteFlare6 = precache_model("sprites/flare6.spr")
	g_spriteBlueFlare2 = precache_model("sprites/blueflare2.spr")
	g_spriteRedFlare2 = precache_model("sprites/redflare2.spr")
	precache_sound("debris/beamstart15.wav")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( g_heroID == heroID )
	{
		g_hasDazzlerPower[id] = (mode != 0)
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	sh_uset(id, g_heroID, 0)
}
//----------------------------------------------------------------------------------------------
// RESPOND TO KEYDOWN
public sh_hero_key(id, heroID, key)
{
	if ( g_heroID != heroID || key != SH_KEYDOWN ) return
	if ( !sh_server_info(SH_INROUND) ) return
	if ( !is_user_alive(id) || !g_hasDazzlerPower[id] ) return

	// Let them know they already used their ultimate if they have
	if ( sh_ustatus(id, g_heroID) )
	{
		playSoundDenySelect(id)
		return
	}

	// Dazzler Parameters
	new dazzlerRadius = get_cvar_num("dazzler_radius")
	new shMaxLevel = sh_server_info(SH_MAXLEVELS)
	new playersLevel[SH_MAXSLOTS+1]
	playersLevel[id] = sh_get_user_lvl(id)

	new Float:num, Float:life, Float:size
	num  = 1.0 + 8.0 * ((1.0 * playersLevel[id]) / shMaxLevel)
	life = 1.0 + 8.0 * ((1.0 * playersLevel[id]) / shMaxLevel)
	size = 50 + 150.0 * ((1.0 * playersLevel[id]) / shMaxLevel)

	// just checks to see if this may be causing server crashes...
	if ( life < 1.0 ) life = 1.0
	if ( life > 10.0 ) life = 10.0
	if ( size > 200 ) size = 200.0
	if ( size < 50  ) size = 50.0

	// OK Power dazzle enemies closer than x distance
	new fromOrigin[3], toOrigin[3], distanceBetween
	new count = 0

	get_user_origin(id, fromOrigin)

	for ( new x = 1; x <= SH_MAXSLOTS; x++ )
	{
		if ( is_user_alive(x) && cs_get_user_team(id) != cs_get_user_team(x) )
		{
			get_user_origin(x, toOrigin)
			distanceBetween = get_distance(fromOrigin, toOrigin )
			if ( distanceBetween < dazzlerRadius )
			{
				// tracer fireworks
				dazzlerSpriteFlash(toOrigin, toOrigin, floatround(num), floatround(life), floatround(size), 10)
				dazzlerSpriteFlash(fromOrigin, toOrigin, 10, 5, 10, 1000)
				emit_sound(id, CHAN_STATIC, "debris/beamstart15.wav", 1.0, ATTN_NORM, 0, PITCH_HIGH)
				emit_sound(x, CHAN_STATIC, "debris/beamstart15.wav", 1.0, ATTN_NORM, 0, PITCH_HIGH)
				count++
			}
		}
	}

	if ( count > 0 ) sh_utimer(id, g_heroID, get_cvar_float("dazzler_cooldown"))
}
//----------------------------------------------------------------------------------------------
public dazzlerSpriteFlash(fromOrigin[3], toOrigin[3], count, life, size, speed)
{
	new num = random_num(1, 4)
	new sprite

	if ( num == 1 ) sprite = g_spriteFlare3
	if ( num == 2 ) sprite = g_spriteFlare6
	if ( num == 3 ) sprite = g_spriteBlueFlare2
	if ( num == 4 ) sprite = g_spriteRedFlare2

	//TE_SPRITETRAIL - GLOW SPRITE
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(15)				// line of moving glow sprites with gravity, fadeout, and collisions
	write_coord(fromOrigin[0])	// pos
	write_coord(fromOrigin[1])
	write_coord(fromOrigin[2])
	write_coord(toOrigin[0])		// pos
	write_coord(toOrigin[1])
	write_coord(toOrigin[2]+100)
	write_short(sprite)	// (sprite index)
	write_byte(count)	// (count)
	write_byte(life)	// (life in 0.1's)
	write_byte(size)	// byte (scale in 0.1's)
	write_byte(speed)	// (velocity along vector in 10's)
	write_byte(5)		// (randomness of velocity in 10's)
	message_end()
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
{
	g_hasDazzlerPower[id] = false
}
//----------------------------------------------------------------------------------------------