// HOBGOBLIN! - Extra Nade Damage/Refill Nade

/* CVARS - copy and paste to shconfig.cfg

//Hobgoblin
hgoblin_level 0
hgoblin_grenademult 1.5		//Damage multiplyer from orginal damage amount
hgoblin_grenadetimer 10		//How many second delay for new grenade

*/

// v1.17 - JTP - Fixed giving new genades using more reliable event

#include <amxmodx>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Hobgoblin"
new g_heroID
new bool:g_hasGoblinPower[SH_MAXSLOTS+1]
#define AMMOX_HEGRENADE 12
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Hobgoblin", "1.18", "{HOJ} Batman/JTP10181")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("hgoblin_level", "0")
	register_cvar("hgoblin_grenademult", "1.5")
	register_cvar("hgoblin_grenadetimer", "10")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Hobgoblin Grenades", "Extra Nade Damage/Refill Nade")
	sh_hero_bind(g_heroID, false)
	sh_hero_level(g_heroID, get_cvar_num("hgoblin_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// EXTRA NADE DAMAGE
	register_event("Damage", "goblin_damage", "b", "2!0")

	//Find Thrown Grenades
	register_event("AmmoX", "on_AmmoX", "b")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( g_heroID == heroID )
	{
		if ( mode == 1 )
		{
			give_grenade(id)
		}
		g_hasGoblinPower[id] = (mode != 0)
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	if ( sh_server_info(SH_MODACTIVE) && g_hasGoblinPower[id] && is_user_alive(id) )
	{
		set_task(0.1, "give_grenade", id)
	}
}
//----------------------------------------------------------------------------------------------
public give_grenade(id)
{
	if ( sh_server_info(SH_MODACTIVE) && g_hasGoblinPower[id] && is_user_alive(id) )
	{
		sh_GiveWeapon(id, "weapon_hegrenade")
	}
}
//----------------------------------------------------------------------------------------------
public goblin_damage(id)
{
	if ( !sh_server_info(SH_MODACTIVE) || !is_user_alive(id) ) return

	new damage = read_data(2)
	new weapon, bodypart, attacker = get_user_attacker(id, weapon, bodypart)

	if ( attacker <=0 || attacker > SH_MAXSLOTS ) return

	if ( g_hasGoblinPower[attacker] && weapon == CSW_HEGRENADE && is_user_alive(id) )
	{
		// Damage that is added to damage already caused
		new extraDamage = floatround(damage * get_cvar_float("hgoblin_grenademult") - damage)
		if (extraDamage > 0) sh_extradamage(id, attacker, extraDamage, "grenade")
	}
}
//----------------------------------------------------------------------------------------------
public on_AmmoX(id)
{
	if ( !sh_server_info(SH_MODACTIVE) ) return
	if ( id <= 0 || id > SH_MAXSLOTS ) return
	if ( !is_user_alive(id) || !is_user_connected(id) ) return

	new iAmmoType = read_data(1)
	new iAmmoCount = read_data(2)

	if ( iAmmoType == AMMOX_HEGRENADE && g_hasGoblinPower[id] )
	{
		if ( iAmmoCount == 0 )
		{
			set_task(get_cvar_float("hgoblin_grenadetimer"), "give_grenade", id)
		}
		else if ( iAmmoCount > 0 && task_exists(id) )
		{
			remove_task(id)
		}
	}
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
{
	g_hasGoblinPower[id] = false
}
//----------------------------------------------------------------------------------------------