// IRON MAN! - BASED ON JETPACK By Lazy / Modifications by OLO

/* CVARS - copy and paste to shconfig.cfg

//Iron Man
ironman_level 0
ironman_timer 0.1			//How often (seconds) to run the loop
ironman_thrust 125			//The upward boost every loop
ironman_maxspeed 400		//Max x and y speeds (while in air)
ironman_xymult 1.05			//Multiplies the current x,y vector when moving
ironman_armorfuel 1			//Uses armor as fuel
ironman_fuelcost 1			//How much armor does it cost per firing
ironman_armor 100			//How much armor does ironman start with?

*/

#include <amxmodx>
#include <engine>
#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Iron Man"
new g_heroID
new bool:g_hasIronMan[SH_MAXSLOTS+1]
new bool:g_regenAllowed[SH_MAXSLOTS+1]
new bool:g_jetPackRunning[SH_MAXSLOTS+1]
new g_maxArmor[SH_MAXSLOTS+1]
new g_spriteFire

// BECAUSE THIS LOOP IS CALLED SO MUCH - INSTEAD OF READING CVARS OVER AND OVER
// I'LL KEEP IN GLOBAL - FOR ANTI-LAG HOPEFULLY
new g_thrust, Float:g_maxSpeed, g_useFuel, g_fuelCost, Float:g_multiplier
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Iron Man", "1.18", "{HOJ} Batman/JTP10181")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("ironman_level", "0")
	register_cvar("ironman_timer", "0.1")
	register_cvar("ironman_thrust", "125")
	register_cvar("ironman_maxspeed", "400")
	register_cvar("ironman_xymult", "1.05")
	register_cvar("ironman_armorfuel", "1")
	register_cvar("ironman_fuelcost", "1")
	register_cvar("ironman_armor", "100")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Rocket Pack", "Rocket Jetpack - Jump and rocket to take off")
	sh_hero_bind(g_heroID, true)
	sh_hero_level(g_heroID, get_cvar_num("ironman_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// DEATH
	register_event("DeathMsg", "ironman_death", "a")

	// Let Server know about the heroes variables
	sh_set_hero_vars(g_heroID, 0, get_cvar_num("ironman_armor"))
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	g_spriteFire = precache_model("sprites/fire.spr")
	precache_sound("ambience/flameburst1.wav")
	precache_sound("debris/beamstart11.wav")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( g_heroID == heroID )
	{
		//Clear out any stale tasks
		remove_task(id)

		if ( mode == 1 )
		{
			set_task(get_cvar_float("ironman_timer"), "ironman_loop", id, "", 0, "b")
		}

		g_hasIronMan[id] = (mode != 0)
	}
}
//----------------------------------------------------------------------------------------------
public plugin_cfg()
{
	loadCVARS()
}
//----------------------------------------------------------------------------------------------
public loadCVARS()
{
	g_thrust = get_cvar_num("ironman_thrust")
	g_maxSpeed = get_cvar_float("ironman_maxspeed")
	g_multiplier = get_cvar_float("ironman_xymult")
	g_useFuel = get_cvar_num("ironman_armorfuel")
	g_fuelCost = get_cvar_num("ironman_fuelcost")
}
//----------------------------------------------------------------------------------------------
public sh_round_start()
{
	for ( new id = 1; id <= SH_MAXSLOTS; id++ )
	{
		if ( !is_user_alive(id) || !g_hasIronMan[id] ) continue

		g_maxArmor[id] = cs_get_user_armor(id, CS_ARMOR_VESTHELM)
		g_regenAllowed[id] = true
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	if ( !sh_server_info(SH_INROUND) ) return

	g_regenAllowed[id] = false
	set_task(1.0, "spawnDelay", id)
}
//----------------------------------------------------------------------------------------------
public spawnDelay(id)
{
	if ( !is_user_alive(id) ) return
	g_maxArmor[id] = cs_get_user_armor(id, CS_ARMOR_VESTHELM)
	g_regenAllowed[id] = true
}
//----------------------------------------------------------------------------------------------
// RESPOND TO KEYDOWN
public sh_hero_key(id, heroID, key)
{
	if ( g_heroID != heroID ) return

	if ( key == 1 )
	{
		if ( !sh_server_info(SH_INROUND) ) return
		if ( !is_user_alive(id) || !g_hasIronMan[id] ) return

		g_jetPackRunning[id] = true
		set_user_info(id,"JP","1")

		//Reload CVARS to make sure the variables are current
		loadCVARS()
	}
	else
	{
		if ( !g_jetPackRunning[id] ) return

		g_jetPackRunning[id] = false
		set_user_info(id, "JP", "0")

		emit_sound(id, CHAN_WEAPON, "debris/beamstart11.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
}
//----------------------------------------------------------------------------------------------
public ironman_loop(id)
{
	new Float:velocity[3]
	new origin[3], userArmor

	if ( !is_user_alive(id) || !g_regenAllowed[id] ) return

	// Increase armor for this guy
	userArmor = cs_get_user_armor(id, CS_ARMOR_VESTHELM)

	if ( userArmor < g_maxArmor[id] && !g_jetPackRunning[id] )
	{
		//Set the armor to what we want it to be
		cs_set_user_armor(id, userArmor + 1, CS_ARMOR_VESTHELM)
		return
	}

	// OK - We'll make this armor based - but also add armor
	// So you can run out of fuel, but get it back too
	if ( g_useFuel != 0 && g_fuelCost > userArmor && g_jetPackRunning[id] )
	{
		playSoundDenySelect(id)
		g_jetPackRunning[id] = false
		set_user_info(id, "JP", "0")
		emit_sound(id, CHAN_WEAPON, "debris/beamstart11.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		client_print(id, print_center, "[SH](Ironman) You ran out of Rocket Pack Fuel")
		return
	}

	if ( g_jetPackRunning[id] )
	{
		// Decrement Fuel
		if ( g_useFuel != 0 )
		{
			cs_set_user_armor(id, userArmor - g_fuelCost, CS_ARMOR_VESTHELM)
		}

		entity_get_vector(id, EV_VEC_velocity, velocity)

		velocity[0] = velocity[0] * g_multiplier
		velocity[1] = velocity[1] * g_multiplier
		velocity[2] += float(g_thrust)

		if ( velocity[0] > g_maxSpeed ) velocity[0] = g_maxSpeed
		if ( velocity[0] < (g_maxSpeed * -1) ) velocity[0] = g_maxSpeed * -1
		if ( velocity[1] > g_maxSpeed ) velocity[1] = g_maxSpeed
		if ( velocity[1] < (g_maxSpeed * -1) ) velocity[1] = g_maxSpeed * -1
		if ( velocity[2] > g_thrust * 2.0 ) velocity[2] = g_thrust * 2.0

		entity_set_vector(id, EV_VEC_velocity, velocity)

		get_user_origin(id, origin, 0)
		jetPackFireEffect(origin)
		emit_sound(id, CHAN_WEAPON, "ambience/flameburst1.wav", 1.0, ATTN_NORM, 0, PITCH_LOW)
	}
}
//----------------------------------------------------------------------------------------------
public jetPackFireEffect(location[3])
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(17)
	write_coord(location[0])
	write_coord(location[1])
	write_coord(location[2])
	write_short(g_spriteFire)
	write_byte(5)
	write_byte(125)
	message_end()
}
//----------------------------------------------------------------------------------------------
public ironman_death()
{
	new id = read_data(2)

	if ( id <= 0 || id > SH_MAXSLOTS ) return

	g_jetPackRunning[id] = false
	set_user_info(id, "JP", "0")
	g_regenAllowed[id] = false
}
//----------------------------------------------------------------------------------------------
public client_disconnect(id)
{
	// stupid check but lets see
	if ( id <= 0 || id > SH_MAXSLOTS ) return

	g_hasIronMan[id] = false
	g_jetPackRunning[id] = false
	set_user_info(id, "JP", "0")
	g_regenAllowed[id] = false

	// Yeah don't want any left over residuals
	remove_task(id)
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
{
	// stupid check but lets see
	if ( id <= 0 || id > SH_MAXSLOTS ) return

	g_hasIronMan[id] = false
	g_jetPackRunning[id] = false
	set_user_info(id, "JP", "0")
	g_regenAllowed[id] = false

	// Yeah don't want any left over residuals
	remove_task(id)
}
//----------------------------------------------------------------------------------------------