// Kamikaze! - Credits AssKicR & Scarzzurs/The_Unbound & {HOJ} Batman

/* CVARS - copy and paste to shconfig.cfg

//Kamikaze
kamikaze_level 0
kamikaze_radius 300			//Radius of people affected by blast
kamikaze_fuse 15			//# of seconds before kamikaze blows Up
kamikaze_maxdamage 125		//Maximum damage to deal to a player

*/

#include <amxmodx>
#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Kamikaze"
new g_heroID
new bool:g_hasKamikaze[SH_MAXSLOTS+1]
new g_kamikazeTimer[SH_MAXSLOTS+1]
new g_spriteSmoke, g_spriteWhite, g_spriteFire
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Kamikaze", "1.18", "AssKicR/JTP10181")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("kamikaze_level", "0")
	register_cvar("kamikaze_radius", "300")
	register_cvar("kamikaze_fuse", "15")
	register_cvar("kamikaze_maxdamage", "125")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Blow Self Up", "Blow up the enemies with a Kamikaze attack")
	sh_hero_bind(g_heroID, true)
	sh_hero_level(g_heroID, get_cvar_num("kamikaze_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// DEATH
	register_event("DeathMsg", "kamikaze_death", "a")

	// Timer loop
	set_task(1.0, "kamikaze_fuse", 0, "", 0, "b")
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	g_spriteSmoke = precache_model("sprites/steam1.spr")
	g_spriteWhite = precache_model("sprites/white.spr")
	g_spriteFire = precache_model("sprites/explode1.spr")
	precache_sound( "buttons/blip2.wav")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( g_heroID == heroID )
	{
		g_hasKamikaze[id] = (mode != 0)
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	sh_uset(id, g_heroID, 0)
	g_kamikazeTimer[id] = 0
}
//----------------------------------------------------------------------------------------------
// RESPOND TO KEYDOWN
public sh_hero_key(id, heroID, key)
{
	if ( g_heroID != heroID || key != SH_KEYDOWN ) return
	if ( !sh_server_info(SH_INROUND) ) return
	if ( !is_user_alive(id) || !g_hasKamikaze[id] ) return

	// Let them know they already used their ultimate if they have
	if ( sh_ustatus(id, g_heroID) )
	{
		playSoundDenySelect(id)
		return
	}

	sh_uset(id, g_heroID, 1)

	g_kamikazeTimer[id] = get_cvar_num("kamikaze_fuse")
}
//----------------------------------------------------------------------------------------------
public kamikaze_fuse()
{
	for ( new id = 1; id <= SH_MAXSLOTS; id++ )
	{
		if ( g_kamikazeTimer[id] > 0 ) kamikaze_check(id)
	}
}
//----------------------------------------------------------------------------------------------
public kamikaze_check(id)
{
	emit_sound(id, CHAN_ITEM, "buttons/blip2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

	g_kamikazeTimer[id] -= 1

	if ( g_kamikazeTimer[id] <= 0 )
	{
		BlowUp(id)
	}
	else {
		// Decrement the counter
		set_hudmessage(0, 100, 200, 0.05, 0.65, 2, 0.02, 1.0, 0.01, 0.1, 85)
		show_hudmessage(id, "You will explode in %d seconds.", g_kamikazeTimer[id])

		// Say Time Remaining to the User Only.
		if ( g_kamikazeTimer[id] == 11 ) client_cmd(id,"spk ^"fvox/remaining^"")
		if ( g_kamikazeTimer[id] < 11 )
		{
			new temp[48]
			num_to_word(g_kamikazeTimer[id], temp, 47)
			client_cmd(id, "spk ^"fvox/%s^"", temp)
		}
	}
}
//----------------------------------------------------------------------------------------------
public BlowUp(id)
{
	new Float:dRatio, damage, distanceBetween
	new damradius = get_cvar_num("kamikaze_radius")
	new maxdamage = get_cvar_num("kamikaze_maxdamage")
	g_kamikazeTimer[id] = 0

	new name[32]
	get_user_name(id, name, 31)
	sh_Unglow(id)
	set_hudmessage(0, 100, 200, 0.05, 0.65, 2, 0.02, 1.0, 0.01, 0.1, 85)
	show_hudmessage(0, "%s has exploded.", name)
	new FFOn = get_cvar_num("mp_friendlyfire")
	new origin[3], origin1[3]
	get_user_origin(id, origin)

	explode(origin) // blowup even if dead

	for ( new a = 1; a <= SH_MAXSLOTS; a++ )
	{
		if( is_user_alive(a) && ( cs_get_user_team(id) != cs_get_user_team(a) || FFOn || a == id ) )
		{
			get_user_origin(a, origin1)

			distanceBetween = get_distance(origin, origin1)
			if( distanceBetween < damradius )
			{
				if ( a == id )
				{
					damage = maxdamage * 4
				}
				else
				{
					dRatio = float(distanceBetween) / float(damradius)
					damage = maxdamage - floatround(maxdamage * dRatio)
				}
				sh_extradamage(a, id, damage, "Kamikaze Bomber")
			} // distance
		} // alive
	} // loop
}
//----------------------------------------------------------------------------------------------
public explode(vec1[3])
{
	// blast circles
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY, vec1)
	write_byte(21)
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2] + 16)
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2] + 1936)
	write_short(g_spriteWhite)
	write_byte(0)		// startframe
	write_byte(0)		// framerate
	write_byte(2)		// life
	write_byte(20)		// width
	write_byte(0)		// noise
	write_byte(188)	// r
	write_byte(220)	// g
	write_byte(255)	// b
	write_byte(255)	// brightness
	write_byte(0)		// speed
	message_end()

	// Explosion2
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(12)		//TE_EXPLOSION2
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_byte(188)	// scale in 0.1's
	write_byte(10)		// framerate
	message_end()

	// Explosion
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY, vec1)
	write_byte(3)		// TE_EXPLOSION
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_short(g_spriteFire)
	write_byte(60)		// scale in 0.1's
	write_byte(10)		// framerate
	write_byte(0)		// flags
	message_end()

	// Smoke
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY, vec1)
	write_byte(5)		// TE_SMOKE
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_short(g_spriteSmoke)
	write_byte(10)		// scale in 0.1's
	write_byte(10)		// framerate
	message_end()
}
//----------------------------------------------------------------------------------------------
public kamikaze_death()
{
	new id = read_data(2)

	if ( g_kamikazeTimer[id] > 0 ) BlowUp(id)
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
{
	g_hasKamikaze[id] = false
	g_kamikazeTimer[id] = 0
}
//----------------------------------------------------------------------------------------------
public client_disconnect(id)
{
	g_hasKamikaze[id] = false
	g_kamikazeTimer[id] = 0
}
//----------------------------------------------------------------------------------------------