// SHADOWCAT! from the X-men, Kitty Pryde can walk thu walls.
// Hero Originally named NightCrawler, changed since powers did not fit.

/* CVARS - copy and paste to shconfig.cfg

//Shadowcat
shadowcat_level 0
shadowcat_cooldown 30		//# of seconds before NightCrawler can NoClip Again
shadowcat_cliptime 6		//# of seconds NightCrawler has in noclip mode.

*/

#include <amxmodx>
#include <engine>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Shadowcat"
new g_heroID
new bool:g_hasShadowcat[SH_MAXSLOTS+1]
new g_shadowcatTimer[SH_MAXSLOTS+1]
new g_lastPosition[SH_MAXSLOTS+1][3]   // Variable to help with position checking
new g_soundShadowcat[]="ambience/alien_zonerator.wav"
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Shadowcat", "1.18", "{HOJ} Batman")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("shadowcat_level", "0")
	register_cvar("shadowcat_cooldown", "30")
	register_cvar("shadowcat_cliptime", "6")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Walk Through Walls", "Can Walk Through Walls for Short Time - GET STUCK AND YOU'LL BE AUTO-SLAIN!")
	sh_hero_bind(g_heroID, true)
	sh_hero_level(g_heroID, get_cvar_num("shadowcat_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// DEATH
	register_event("DeathMsg", "shadowc_death", "a")

	// LOOP
	set_task(1.0, "shadowc_loop", 0, "", 0, "b")
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	// TBD - May want to do Ludwigs scotty teleport graphics later for this...
	precache_sound(g_soundShadowcat)
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( g_heroID == heroID )
	{
		g_hasShadowcat[id] = (mode != 0)

		if ( !mode )
		{
			if ( g_shadowcatTimer[id] >= 0 )
			{
				shadowc_endnoclip(id)
			}
		}
		else
		{
			// Make sure looop doesn't fire for them
			g_shadowcatTimer[id] = -1
		}
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	sh_uset(id, g_heroID, 0)
	g_shadowcatTimer[id]= -1
	if (g_hasShadowcat[id])
	{
		shadowc_endnoclip(id)
	}
}
//----------------------------------------------------------------------------------------------
// RESPOND TO KEYDOWN
public sh_hero_key(id, heroID, key)
{
	if ( g_heroID != heroID || key != SH_KEYDOWN ) return
	if ( !sh_server_info(SH_INROUND) ) return
	if ( !is_user_alive(id) || !g_shadowcatTimer[id] ) return

	// Make sure they're not in the middle of clip already
	// Let them know they already used their ultimate if they have
	if ( sh_ustatus(id, g_heroID) || g_shadowcatTimer[id] > 0 )
	{
		playSoundDenySelect(id)
		return
	}

	//If the user already has noclip (prob from another hero) cancel this keydown
	if ( get_user_noclip(id) == 1 )
	{
		client_print(id, print_chat, "[SH](Shadowcat) You are already using noclip")
		playSoundDenySelect(id)
		return
	}

	g_shadowcatTimer[id] = get_cvar_num("shadowcat_cliptime")
	set_user_noclip(id, 1)
	sh_utimer(id, g_heroID, get_cvar_float("shadowcat_cooldown"))

	// NightCrawler Messsage
	new message[128]
	format(message, 127, "Entered Shadowcat Mode^nDon't get Stuck or you will die")
	set_hudmessage(255, 0, 0, -1.0, 0.3, 0, 0.25, 1.2, 0.0, 0.0, 87)
	show_hudmessage(id, message)
	emit_sound(id, CHAN_STATIC, g_soundShadowcat, 0.2, ATTN_NORM, 0, PITCH_LOW)
}
//----------------------------------------------------------------------------------------------
public shadowc_loop()
{
	for ( new id = 1; id <= SH_MAXSLOTS; id++ )
	{
		if ( g_hasShadowcat[id] && is_user_alive(id) )
		{
			if ( g_shadowcatTimer[id] > 0 )
			{
				new message[128]
				format(message, 127, "%d seconds left of Shadowcat Mode^nDon't get Stuck or you will die", g_shadowcatTimer[id])
				set_hudmessage(255, 0, 0, -1.0, 0.3, 0, 1.0, 1.2, 0.0, 0.0, 87)
				show_hudmessage(id, message)
				g_shadowcatTimer[id]--
			}
			else if ( g_shadowcatTimer[id] == 0 )
			{
				g_shadowcatTimer[id]--
				shadowc_endnoclip(id)
			}
		}
	}
}
//----------------------------------------------------------------------------------------------
public shadowc_endnoclip(id)
{
	if ( !is_user_connected(id) ) return

	g_shadowcatTimer[id] = -1
	stopSound(id)

	if ( !is_user_alive(id) ) return
	if ( get_user_noclip(id) == 1 )
	{
		// Turn off no-clipping and make sure the user has moved
		set_user_noclip(id, 0)
		positionChangeTimer(id)
	}
}
//----------------------------------------------------------------------------------------------
public stopSound(id)
{
	new SND_STOP=(1<<5)
	emit_sound(id, CHAN_STATIC, g_soundShadowcat, 0.0, ATTN_NORM, SND_STOP, PITCH_LOW)
}
//----------------------------------------------------------------------------------------------
public positionChangeTimer(id)
{
	if ( !is_user_alive(id) ) return

	get_user_origin(id, g_lastPosition[id], 0)

	new Float:velocity[3]
	entity_get_vector(id, EV_VEC_velocity, velocity)

	if ( velocity[0]==0.0 && velocity[1]==0.0 )
	{
		// Force a Move (small jump)
		velocity[0] += 20.0
		velocity[2] += 100.0
		entity_set_vector(id, EV_VEC_velocity, velocity)
	}

	set_task(0.4, "positionChangeCheck", id)
}
//----------------------------------------------------------------------------------------------
public positionChangeCheck(id)
{
	new origin[3]

	if ( !is_user_alive(id) ) return

	get_user_origin(id, origin, 0)
	if ( g_lastPosition[id][0] == origin[0] && g_lastPosition[id][1] == origin[1] && g_lastPosition[id][2] == origin[2] && is_user_alive(id) )
	{
		// Kill this player - NightCrawler Stuck in wall!
		user_kill(id)
	}
}
//----------------------------------------------------------------------------------------------
public shadowc_death()
{
	new id = read_data(2)
	sh_uset(id, g_heroID, 0)
	g_shadowcatTimer[id]= -1
	if (g_hasShadowcat[id])
	{
		shadowc_endnoclip(id)
	}
}
//----------------------------------------------------------------------------------------------