// SKELETOR! from HE-MAN, The evil sorcerer.
// REQUIRES Monster Mod (Botman version 3.00.00)
// Created 5/17/2003

/* CVARS - copy and paste to shconfig.cfg

//Skeletor
skeletor_level 0
skeletor_cooldown 30		// # of seconds for skeletor cooldown
skeletor_camptime 15		// # of seconds player considered camping w/o x/y movement
skeletor_movedist 10		// minimum amount of dist player has to move b4 considered not camping

*/

#include <amxmodx>
#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Skeletor"
new g_heroID
new bool:g_hasSkeletor[SH_MAXSLOTS+1]
new g_playerPosition[SH_MAXSLOTS+1][3]  // keeps track of last known origin
new g_moveTimer[SH_MAXSLOTS+1]          // incremented if player didn't move far enough
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Skeletor", "1.18", "{HOJ} Batman")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("skeletor_level", "0")
	register_cvar("skeletor_cooldown", "30")
	register_cvar("skeletor_camptime", "15")
	register_cvar("skeletor_movedist", "10")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Summon Monsters", "Will Automatically Summon Monsters To Attack Enemy Campers")
	sh_hero_bind(g_heroID, false)
	sh_hero_level(g_heroID, get_cvar_num("skeletor_level"))

	// LOOP
	set_task(1.0, "skeletor_campcheck", 0, "", 0, "b")
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	precache_sound("ambience/port_suckin1.wav")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( g_heroID == heroID )
	{
		g_hasSkeletor[id] = (mode != 0)
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	g_moveTimer[id] = 0
	sh_uset(id, g_heroID, 0)

	if ( is_user_alive(id) )
	{
		get_user_origin(id, g_playerPosition[id])
	}
}
//----------------------------------------------------------------------------------------------
public skeletor_campcheck()
{
	if ( !sh_server_info(SH_MODACTIVE) || !sh_server_info(SH_INROUND) ) return

	// Check all players to see if they've moved...
	new origin[3]
	new dx, dy, dz

	for ( new i = 1; i <= SH_MAXSLOTS; i++ )
	{
		if ( is_user_alive(i) ) {
			get_user_origin(i,origin)
			dx = g_playerPosition[i][0] - origin[0]
			dy = g_playerPosition[i][1] - origin[1]
			dz = g_playerPosition[i][2] - origin[2]
			new d = sqrt( dx*dx + dy*dy + dz*dz )
			if ( d <= get_cvar_num("skeletor_movedist") )
			{
				g_moveTimer[i]++
				if ( g_moveTimer[i] > get_cvar_num("skeletor_camptime") )
				{
					g_moveTimer[i] = 0
					skeletor_summon(i)
				}
			}
			else
			{
				g_moveTimer[i] = 0
			}
			g_playerPosition[i][0] = origin[0]
			g_playerPosition[i][1] = origin[1]
			g_playerPosition[i][2] = origin[2]
		}
	}
}
//----------------------------------------------------------------------------------------------
public skeletor_summon(id)
{
	// Go through a list of skeletor looking for
	// 1) ultimate available
	// 2) opposite team than (id)
	// 3) skeletor powers...
	for ( new i = 1; i <= SH_MAXSLOTS; i++ )
	{
		if ( is_user_alive(i) && g_hasSkeletor[i] && cs_get_user_team(i) != cs_get_user_team(id) && !sh_ustatus(id, g_heroID) )
		{
			// COOL WE HAVE A SKELETOR TO STICK SNARKS ON Player id!
			sh_utimer(i, g_heroID, get_cvar_float("skeletor_cooldown"))
			// SUMMON THE MONSTERS USING MONSTOR MOD
			new name[32]
			new enemyName[32]
			get_user_name(id, enemyName, 31)
			get_user_name(i, name, 31)
			client_print(0, print_chat, "[SH] %s using Skeletor Powers Against Camper %s", name, enemyName)
			emit_sound(id, CHAN_STATIC, "ambience/port_suckin1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			emit_sound(i, CHAN_STATIC, "ambience/port_suckin1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

			// The Higher the Level - The more Snarks!
			//server_print("LEVEL OF %s=%d", name, sh_get_user_lvl(i))
			for ( new m = 1; m <= sh_get_user_lvl(i) / 2 + 1; m++ )
			{
				set_task(m * 0.2, "summon_monster", id)
			}
			break //ok no more poeple need to syc this guy
		}
	}
}
//----------------------------------------------------------------------------------------------
public summon_monster(id)
{
	if ( is_user_alive(id) )
	{
		server_cmd("monster snark #%i", id)
	}
}
//----------------------------------------------------------------------------------------------