// XAVIER! - BASED ON SPACEDUDE'S NEW XTRAFUNMOD - FORGOT WHERE I FOUND THE TRACEME CODE
// 1.14.4 - significant change - no xtrafun needed for this now...

/* CVARS - copy and paste to shconfig.cfg

//Xavier
xavier_level 7
xavier_traillength 25			//Length of trail behind players
xavier_showteam 0				//Show trails on your team
xavier_showenemy 1				//Show trails on enemies
xavier_refreshtimer 5.0			//How often do the trails refresh

*/

#include <amxmodx>
#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Xavier"
new g_heroID
new bool:g_hasXavier[SH_MAXSLOTS+1]
new g_spriteTrail
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Xavier", "1.18", "{HOJ} Batman")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("xavier_level", "7")
	register_cvar("xavier_traillength", "25")
	register_cvar("xavier_showteam", "0")
	register_cvar("xavier_showenemy", "1")
	register_cvar("xavier_refreshtimer", "5.0")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Detect Team", "Detect what team a player is on by a glowing trail")
	sh_hero_bind(g_heroID, false)
	sh_hero_level(g_heroID, get_cvar_num("xavier_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// DEATH
	register_event("DeathMsg", "xavier_death", "a")
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	g_spriteTrail = precache_model("sprites/laserbeam.spr")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( g_heroID == heroID )
	{
		//Clear out any stale tasks
		remove_task(id)

		if ( mode == 1 )
		{
			set_task(get_cvar_float("xavier_refreshtimer"), "trailMoveCheck", id, "", 0, "b")
		}
		else
		{
			removeAllMarks(id)
		}
		//Sets this variable to the current status
		g_hasXavier[id] = (mode != 0)
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	if ( is_user_alive(id) && g_hasXavier[id] ) 
	{
		addAllMarks(id)
	}
}
//----------------------------------------------------------------------------------------------
public trailMoveCheck(id)
{
	// Refresh the Marks...
	addAllMarks(id)
}
//----------------------------------------------------------------------------------------------
public addAllMarks(id)
{
	new players[32], n
	new bool:sameTeam
	new bool:showTeam
	new bool:showEnemy

	if ( is_user_alive(id) && g_hasXavier[id] )
	{
		showTeam = (get_cvar_num("xavier_showteam") != 0)
		showEnemy = (get_cvar_num("xavier_showenemy") != 0)

		get_players(players, n, "a")

		for ( new p = 0; p < n; p++ )
		{
			if ( players[p] == id ) continue

			sameTeam = (cs_get_user_team(id) == cs_get_user_team(players[p]))

			if ( (sameTeam && showTeam) || (!sameTeam && showEnemy) )
			{
				addMark(id, players[p])
			}
		}
	}
}
//----------------------------------------------------------------------------------------------
public addMark(id, pid)
{
	if ( !is_user_alive(pid) ) return

	removeMark(id, pid)
	if ( cs_get_user_team(pid) == CS_TEAM_T )
	{
		make_trail(id, pid, 255, 0, 0, g_spriteTrail)
	}
	else if ( cs_get_user_team(pid) == CS_TEAM_CT )
	{
		make_trail(id, pid, 0, 0, 255, g_spriteTrail)
	}
}
//----------------------------------------------------------------------------------------------
public make_trail(id, markid, iRed, iGreen, iBlue, spr)
{
	if ( id == markid ) return

	if ( !is_user_alive(id) ) return
	
	// Create a beam trail
	message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, {0,0,0}, id)
	write_byte(22)		// TE_BEAMENTS
	write_short(markid)
	write_short(spr)
	write_byte(get_cvar_num("xavier_traillength")) //length
	write_byte(8)      //width
	write_byte(iRed)   //red
	write_byte(iGreen) //green
	write_byte(iBlue)  //blue
	write_byte(150)    //bright
	message_end()
}
//----------------------------------------------------------------------------------------------
public removeAllMarks(id)
{
	new players[32], n

	if ( is_user_connected(id) && g_hasXavier[id] )
	{
		get_players(players, n, "a")
		for ( new p = 0; p < n; p++ )
		{
			if ( players[p] == id ) continue
			removeMark(id, players[p])
		}
	}
}
//----------------------------------------------------------------------------------------------
public removeMark(id, pid)
{
	if ( !is_user_connected(id) ) return
	
	// remove trails
	message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, {0,0,0}, id)
	write_byte(99)		//TE_KILLBEAM
	write_short(pid)
	message_end()
}
//----------------------------------------------------------------------------------------------
public xavier_death()
{
	if ( !sh_server_info(SH_MODACTIVE) ) return

	new victim_id = read_data(2)

	removeAllMarks(victim_id)
}
//----------------------------------------------------------------------------------------------
public client_disconnect(id)
{
	// stupid check but lets see
	if ( id <= 0 || id > SH_MAXSLOTS ) return

	// Yeah don't want any left over residuals
	remove_task(id)
}
//----------------------------------------------------------------------------------------------